@Echo OFF
::unquote src filename
set ext=%~1
::get file extension
set ext=%ext:~-4%

IF /I "%ext%"==".chm" (
IF "%3"=="full" GOTO MAKE_CHM_FULL
GOTO MAKE_CHM_THUMB
)

IF /I "%ext%"==".pdf" (
IF "%3"=="full" GOTO MAKE_PDF_FULL
GOTO MAKE_PDF_THUMB
)
goto:eof

:MAKE_CHM_FULL
set curpath=%~dp0
::check if src filename is in the system temp folder
if exist "%temp%\%~n1%~x1" (
::if yes, don't cache it
"%curpath%chm2image.exe" %1 %2.png -maxHeight 1000
goto:eof
)
call:GenerateCacheFormatFilename %1
::check if already cached
if not exist %cachedImg% goto GENCHM
for %%j in (%cachedImg%) do set ThumbFileDate=%%~tj
for %%j in (%1) do set SrcFileDate=%%~tj
if "%SrcFileDate%" LEQ "%ThumbFileDate%" goto COPYCHM
:GENCHM
::generate it
"%curpath%chm2image.exe" %1 %cachedImg% -maxHeight 1000 
:COPYCHM
::copy cached image file to the requested, by PDFE, file name
copy %cachedImg% %2.png
goto:eof

:MAKE_CHM_THUMB
::generate a unique filename
call:getUniqueFile "%temp%\thumbnail" ".png" Tempfilename
::render chm to temp image
set curpath=%~dp0
"%curpath%chm2image.exe" %1 %Tempfilename% -maxHeight 1000
::convert temp image to thumbnail image
"%curpath%MakeThumb.exe" %Tempfilename% -dropshadow -size 256x256 %2.png
del %Tempfilename%
goto:eof

:MAKE_PDF_FULL
set curpath=%~dp0
::check if src filename is in the system temp folder
if exist "%temp%\%~n1%~x1" (
::if yes, don't cache it
"%curpath%mudraw.exe" -r100 -o %2.png %1 1
goto:eof
)
set curpath=%~dp0
call:GenerateCacheFormatFilename %1
::check if already cached
if not exist %cachedImg% goto GENPDF
for %%j in (%cachedImg%) do set ThumbFileDate=%%~tj
for %%j in (%1) do set SrcFileDate=%%~tj
if "%SrcFileDate%" LEQ "%ThumbFileDate%" goto COPYPDF
:GENPDF
::generate it
"%curpath%mudraw.exe" -r100 -o %cachedImg% %1 1
::copy cached image file to the requested, by PDFE, file name
:COPYPDF
copy %cachedImg% %2.png
goto:eof

:MAKE_PDF_THUMB
call:getUniqueFile "%temp%\thumbnail" ".png" Tempfilename
::render pdf to temp image
set curpath=%~dp0
"%curpath%mudraw.exe" -r100 -o %Tempfilename% %1 1
::convert temp image to thumbnail image
"%curpath%MakeThumb.exe" %Tempfilename% -dropshadow -size 256x256 %2.png
del %Tempfilename%
goto:eof

:GenerateCacheFormatFilename
::take the passed source file name and convert it to a cached file name removing all the '\:.' characters
::unquote src filename
set str=%~1
::remove backslashes
set str=%str:\=%
::remove :
set str=%str::=%
::remove .
set str=%str:.=%
::add big thumbs cache folder path to the cached converted file name
set cachedImg="%curpath%\..\wwwroot\images\bthumbs\%str%.png"
goto:eof

:getUniqueFile  baseName  extension  rtnVar
setlocal
:getUniqueFileLoop
for /f "skip=1" %%A in ('wmic os get localDateTime') do for %%B in (%%A) do set "rtn=%~1_%%B%~2"
if exist "%rtn%" (
  goto :getUniqueFileLoop
) else (
  2>nul >nul (9>"%rtn%" timeout /nobreak 1) || goto :getUniqueFileLoop
)
endlocal & set "%~3=%rtn%"
goto:eof